﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Metabolite : MonoBehaviour
{
    // Start is called before the first frame update

    [SerializeField] string ID;
    [SerializeField] string metaboliteName;
    [SerializeField] float Zscore;

    [SerializeField] Gradient gradient;
    GradientColorKey[] colorKey;
    GradientAlphaKey[] alphaKey;
    IO io;



    public void setZscore(float newZscore)
    {
        Zscore = newZscore;

    }

    public void setID(string newID)
    {
        ID = newID;

    }

    public string getID()
    {
        return ID;

    }

    public void setName(string newName)
    {
        metaboliteName = newName;

    }

    public string getName()
    {
        return metaboliteName;

    }

    public float getZscore()
    {
        return Zscore;

    }

    private void OnMouseDown()
    {
        io.updateSelectedMetabolite(metaboliteName, Zscore);
    }

    void Start()
    {
        io = FindObjectOfType<IO>();
    }

    // Update is called once per frame
    void Update()
    {
        //GetComponent<Renderer>().material.color = new Color(255f*Zscore, 0, 0);
        float transformedZscore = (Zscore+1)/ 2f;
        GetComponent<Renderer>().material.color = gradient.Evaluate(transformedZscore);
    }
}
